import bpy


bl_info = {
    "name": "ue5shapehelper",
    "author": "yumeno",
    "version": (1,4),
    "blender": (3, 3, 1),
    "location": "All Editors",  
    "description": "UE5 Facial shape Helper",
    "support": "TESTING",
    "category": "Object"
}




class UE5_OT_Face(bpy.types.Operator):
  bl_idname = "ue_shape.op"
  bl_label = "ue5_shape_operate"
  bl_options = {'REGISTER', 'UNDO'}
  bl_width_default = 1
  out_int : bpy.props.IntProperty()

  def execute(self,context):
        key = self.out_int
        print(key)
        dict_func = { 1: Shape_Toggle,2 :copy_shape , 3: createshapekyes ,4:reset_selected}
        return dict_func[ key ](context)


#toggle shape key
def Shape_Toggle(content):
    Active_shapekey = bpy.context.object.active_shape_key
    if Active_shapekey.value != 0:
          Active_shapekey.value = 0
    else:
          Active_shapekey.value = 1
    return {'FINISHED'}
#UE5 facial mirror left to right
def copy_shape(content):
    bpy.ops.object.mode_set(mode='OBJECT')
    Active_ShapeKey_Name = bpy.context.object.active_shape_key.name
    lr = Active_ShapeKey_Name[-3:]
    bpy.context.object.active_shape_key.value = 1
    active_obj = bpy.context.active_object
    keys =  active_obj.data.shape_keys.key_blocks.keys()
    for key in keys:
        basename = key[:-4]
        if key[-3:].lower() == "eft" : 
          findrightname =  [s for s in keys if basename + "Right" in s]
          if findrightname == []:
              bpy.ops.object.shape_key_add(from_mix=False)
              bpy.ops.object.mode_set(mode='EDIT')
              bpy.ops.mesh.select_all(action = 'SELECT')
              bpy.ops.mesh.blend_from_shape(shape=key, blend=1.0, add=False)
              bpy.ops.object.mode_set(mode='OBJECT')
              bpy.ops.object.shape_key_mirror(use_topology=False)
              bpy.context.object.active_shape_key.name = basename + "Right"
    return{'FINISHED'}

# create shakeys from shapekyes.txt in addons folder
def createshapekyes(content):
    obj = bpy.context.active_object
    if not obj.data.shape_keys:
        obj.shape_key_add(name="Base")
    shapepath = bpy.utils.script_paths()[1] + '\\addons\\shapekeys.txt' 
    with open(shapepath, 'r') as file:
        for line in file:
            values = line.strip().split(',')
            shape_key_name = values[0]
            existing_shape_key = obj.data.shape_keys.key_blocks.get(shape_key_name)
            if existing_shape_key is None:
                obj.shape_key_add(name=shape_key_name)
    return {'FINISHED'}

def reset_selected(content):
  bpy.ops.mesh.blend_from_shape(shape='Base', blend=1, add=False)
  return {'FINISHED'}


#UI
class UE5_PT_ShapePanel(bpy.types.Panel):
  bl_space_type = 'VIEW_3D'
  bl_region_type = 'UI'
  bl_category = "ue5face"
  bl_label = "UE5shape"

  #--- draw ---#
  def draw(self, context):
    layout = self.layout
    layout.operator(UE5_OT_Face.bl_idname, text = "Shape_mirror").out_int=2
    layout.operator(UE5_OT_Face.bl_idname, text = "create_shapkyes").out_int=3
    layout.operator("mesh.blend_from_shape(blend1.0,add=False)", text = "reset_selected")
    layout.operator(UE5_OT_Face.bl_idname , text = "toggle").out_int=1
    layout.operator(UE5_OT_Face.bl_idname , text="reset_selected").out_int=4

# register classs
classs = [
  UE5_OT_Face,
  UE5_PT_ShapePanel, 
]

# register
def register():
  for c in classs:
    bpy.utils.register_class(c)

# unregister
def unregister():
  for c in classs:
    bpy.utils.unregister_class(c)

# script entry
if __name__ == "__main__":
  register()